#include <stdio.h>
#include <stdlib.h>

#define SIZE_MAX 8

typedef enum {empty, covered, queen} board_state;

typedef struct {
    board_state board[SIZE_MAX][SIZE_MAX];
    int width, height;
} board_t;

int queen_covering(board_t *board, char line, int column){

    for (int ligne = 0; ligne < SIZE_MAX; ++ligne){
    
        for (int colonne =0; colonne < SIZE_MAX; ++colonne){
    
            if (ligne == line-65 && colonne == column) {
    
                board->board[ligne][colonne] = queen;
    
            }else if (ligne == line-65 || colonne == column || abs(line-65-ligne)==abs(column-colonne)){
    
                board->board[ligne][colonne] = covered;

            }else {
                board->board[ligne][colonne] = empty;
            }


        }
    }
}

void print_board(board_t board) {
    char index_h = 'H';
    int index_w = 0;
    for(int i = 0; i < SIZE_MAX +1; ++i) {
        printf("\n");
        for (int j =0; j < SIZE_MAX; ++j) {
            if(j == 0) {
                
                if (i == SIZE_MAX){
                    printf(" ");
                }else {
                    printf("%c ", index_h);
                }
            }
            if(i == SIZE_MAX) {
                if (j != 0) {
                    printf("%d ", j);
                }else {
                    printf(" ");
                }
            }else {
            switch(board.board[i][j]) {
                case covered:
                    printf("* ");
                    break;
                case empty:
                    printf(". ");
                    break;
                case queen:
                    printf("R ");
                    break;
            }
            }


        }
    --index_h;
    }
    printf("%d\n", SIZE_MAX);
}

int main() {

    board_t board;
    queen_covering(&board, 'C', 2);
    print_board(board);
}