#ifndef FRACTIONS_H
#define FRACTIONS_H

struct Fraction {
    int numerator;
    int denominator;
};

// Function prototypes
void display_fraction(struct Fraction frac);
struct Fraction reduce_fraction(struct Fraction frac);
int calculate_gcd(int a, int b);
struct Fraction power_fraction(struct Fraction base, int exponent);
void fraction_add_inplace(struct Fraction *result, const struct Fraction *fraction1, const struct Fraction *fraction2) ;
void fraction_sub_inplace(struct Fraction *result, const struct Fraction *fraction1, const struct Fraction *fraction2) ;



// ... other function prototypes ...

#endif // FRACTIONS_H
